#ifndef	SUS_H
#define SUS_H


#define		PSI_VENDOR_ID						0x0A2F

#define		BULK_TRANS_MAX						1048576
//#define		BULK_TRANS_MAX						32768
#define		USB_TIME_OUT						5000

#define     SUS_VENDER_REQUEST_REGISTER     	0xA0	//	Sigmapڼ޽
#define     SUS_VENDER_REQUEST_DATA         	0xA1	//	Sigmapغ
#define     SUS_VENDER_REQUEST_USBCONFIG    	0xB2
#define     SUS_VENDER_REQUEST_BOARDINFO    	0xB3
#define     SUS_VENDER_REQUEST_I2CWRITE     	0xC0
#define     SUS_VENDER_REQUEST_I2CREAD      	0xC1
#define     SUS_VENDER_REQUEST_GETTEMP      	0xC2
#define     SUS_VENDER_REQUEST_I2CWRITE2     	0xC3
#define     SUS_VENDER_REQUEST_I2CREAD2      	0xC4
#define     SUS_VENDER_REQUEST_I2CWRITE3 		0xC5
#define     SUS_VENDER_REQUEST_I2CREAD3  		0xC6
#define     SUS_VENDER_REQUEST_TEMP_ALERT 		0xC7
#define     SUS_VENDER_REQUEST_WATCH_DOG	 	0xC8
#define     SUS_VENDER_REQUEST_FX3_RESET	 	0xC9


//  ظ(A1h) ް]޺
#define     SUS_DATA_TRANS_OUT_START        	0xC0
#define     SUS_DATA_TRANS_OUT_END          	0x40
#define     SUS_DATA_TRANS_IN_START         	0x80
#define     SUS_DATA_TRANS_IN_END           	0x00

//  ظ(B2h) USB̨޺޺
#define     SUS_USBCONFIG_START            		0xC1
#define     SUS_USBCONFIG_END              		0x41
#define     SUS_CFG_STS_ADRS					2
#define     SUS_CFG_STATUS_SUCCESS				0

//  ظ(B3h) ްޏ擾ނ̎擾I
#define     SUS_BOARDINFO_API_BUILD            	0x0013
#define     SUS_BOARDINFO_API_PATCH            	0x0012
#define     SUS_BOARDINFO_API_MINOR            	0x0011
#define     SUS_BOARDINFO_API_MAJOR            	0x0010
#define     SUS_BOARDINFO_FIRMID            	0x00C0
#define     SUS_BOARDINFO_CHIPVER           	0x0080
#define     SUS_BOARDINFO_PID               	0x0040
#define     SUS_BOARDINFO_SPEED             	0x0000
#define     SUS_FULL_SPEED                  	0x0000
#define     SUS_HIGH_SPEED                  	0x0001
#define     SUS_SUPER_SPEED                  	0x0002

//	ظ(C7h)Ұ
#define		SUS_TEMP_ALERT_SET					0
#define		SUS_TEMP_ALERT_GET					1

//	ظ(C8h)Ұ
#define		SUS_WATCH_DOG_SET					0
#define		SUS_WATCH_DOG_GET					1

//	---------------------------------------------------------------------------
//	Plusذ޺ޗpҰ
//	---------------------------------------------------------------------------
#define     SUP64_RANGE_8BIT                  	0x00        //  8ޯ
#define     SUP64_RANGE_16BIT                 	0x40        //  16ޯ
#define     SUP64_RANGE_32BIT                 	0x80        //  32ޯ
#define     SUP64_RANGE_64BIT                 	0xC0        //  64ޯ

#define     SUP64_ADRS_LOW_MASK                	0x003F
#define     SUP64_ADRS_HIGH_MASK               	0x3FC0
#define     SUP64_RANGE_MASK                	0x00C0

#define     SUP64_DIRECTION_DEVICE_TO_HOST		0xC0        //  ޲  ν
#define     SUP64_DIRECTION_HOST_TO_DEVICE		0x40        //  ν  ޲
#define     SUP64_VENDER_REQUEST_REGISTER     	0xB0
#define		SUP64_VENDER_REQUEST_BULK_TRANS		0xB1
#define     SUP64_CFG_STS_ADRS				    2

#define     SUP64_DATA_TRANS_OUT_START        	0xC0
#define     SUP64_DATA_TRANS_OUT_END          	0x40
#define		SUP64_WRITE_EP_ADRS					0x06

//	---------------------------------------------------------------------------
//	^錾
//	---------------------------------------------------------------------------
union	UNION_8BYTE	{

	unsigned long long	qword;
	unsigned int		dword[2];
	unsigned short  	word[4];
	unsigned char		byte[8];
};

union	UNION_4BYTE	{

	unsigned int	dword;
	unsigned short  word[2];
	unsigned char	byte[4];
};

union	UNION_2BYTE	{

	unsigned short  word;
	unsigned char	byte[2];
};

//  //۰ފ֐
//bool	SUS_Usb_Init( libusb_context *ctx );
//bool	SUS_Usb_Open( int pid, libusb_device_handle **handle );
//void	SUS_Usb_Close( libusb_context *ctx, libusb_device_handle *handle );
//void	SUS_Usb_Exit( libusb_context *ctx );

//	հèè֐
bool	SUS_Get_BoardInfo( usb_dev_handle *handle, unsigned short sel, unsigned short *id );
bool	SUS_Usb_Config( usb_dev_handle *handle, char *filename );
bool	SUS_Usb_Config_KXCARD7( usb_dev_handle *handle, char *filename, bool encrypt );
bool	SUS_Usb_Config_CXCARD5( usb_dev_handle *handle, char *filename );
bool	SUS_Usb_Deconfig( usb_dev_handle *handle );
bool	SUS_Get_FPGA_Temp( usb_dev_handle *handle, unsigned short sel, unsigned short *temp );
bool	SUS_I2c_Read( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char *Rd );
bool	SUS_I2c_Write( usb_dev_handle *handle, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char Wd );
bool	SUS_I2c_ReadEx( usb_dev_handle *handle, unsigned char port, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char *Rd );
bool	SUS_I2c_WriteEx( usb_dev_handle *handle, unsigned char port, unsigned char DevAdrs, unsigned char RegAdrs, unsigned char Wd );
bool	SUS_I2c_ReadEx2( usb_dev_handle *handle, unsigned char port, unsigned char cmd_length, unsigned short read_length, unsigned char *iic_cmd, unsigned char *rd );
bool	SUS_I2c_WriteEx2( usb_dev_handle *handle, unsigned char port, unsigned char cmd_length, unsigned short write_length, unsigned char *iic_cmd );
bool	SUS_Temp_Alert( usb_dev_handle *handle, bool dir, unsigned char wd, unsigned char *rd );
bool	SUS_WatchDog( usb_dev_handle *handle, bool dir, unsigned char wd, unsigned char *rd );
bool	SUS_FX3Reset( usb_dev_handle *handle );


bool	VIEW_BoardInfo( usb_dev_handle *handle );

//	ؓ]֐
bool	SUS_Data_Read( usb_dev_handle *handle, char *filename, unsigned int length );
bool	SUS_Data_Write( usb_dev_handle *handle, char *filename, unsigned int length );

//	ڼ޽֐
bool	SUS_Reg_Write( usb_dev_handle *handle, unsigned int adrs, unsigned short size, unsigned char *wd );
bool	SUS_Reg_Read( usb_dev_handle *handle, unsigned int adrs, unsigned short size, unsigned char *rd );

//	ؓ]ڼ޽֐(PlusӰ) ׂ݊̈ɒǉ
bool	SUP64_Reg_Read( usb_dev_handle *handle, unsigned short adrs, unsigned char range, union UNION_8BYTE *rd );
bool	SUP64_Data_Write( usb_dev_handle *handle, unsigned char range, unsigned int size, unsigned char *pbuffer );

//	̑
bool	SUS_Mem_Cmd( usb_dev_handle *handle, unsigned char cmd, unsigned int length );

#endif
