//	----------------------------------------------------------------------------------------------------------------
//	SUS޲plibusbٿĳ USB̨ڰݻ
//	
//	2020.05.04	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂ͓mF
//	
//	
//	
//	
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUS.h"

int		main( int argc, char **argv	)
{

	FILE				*fp;
	char				filename[256];
	unsigned int		size;
	int					i;
	int					pid = 0;
	char				mode[256];
	unsigned char		encrypt = 0;

	int					find = 0;
	unsigned short		id;

	struct				usb_bus *busses;
	struct				usb_bus	*bus;
	struct				usb_device	*dev;
	struct				usb_device	*target_dev;
	usb_dev_handle		*handle;

	union UNION_8BYTE	rd;


	struct				timeval	t1, t2;
	long				lapsed_time;
	long				lapsed_sec;
	long				lapsed_usec;


	printf("\nSUSConfig Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Sigma Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("\nexample) ./SUSConfig -f./SX-Card7.bin [-p8005]\n");
	printf("example) ./SUSConfig -f./KX-Card7_GPIF2_Verilog.bin [-mX] [-e] [-p8001]\n");
	printf("example) ./SUSConfig -f./BIN/CX-Card5_GPIF2_Verilog.rbf -mC [-p8002]\n");
	printf("example) ./SUSConfig -f./BIN/SX-USB4_GPIF2_Verilog.rbf -mS [-p8000]\n");
	printf("-f ... BIN/RBF finename.(required)\n");
	printf("-p ... Target ProductID.(optional)\n");
	printf("-m ... Configuration mode.(optional)\n");
	printf("-e ... Xilinx Encrypt option.(optional)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-f%s", &filename );
		sscanf( argv[i], "-p%x", &pid  );
		sscanf( argv[i], "-m%s", &mode  );

		if(( argv[i][1] == 'e' ) | 	( argv[i][1] == 'E' ))
		{
			encrypt = 1;
		}
	}

	//	Ұ΂̂܂܏I
	if( argc == 1 )
	{
		//	I
		printf("No Operation ................ DONE!!\n");
		return	false;
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Sigma ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Sigma ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Sigma ... Device not found!!\n" );
		return	false;
	}
	printf("\nConfiguration target %04X:%04X device.\n", target_dev->descriptor.idVendor, target_dev->descriptor.idProduct );

	//	̧ق̊mF
	if(( fp = fopen( filename, "rb" )) == NULL )
	{
		printf("Cannot found [%s]\n\n",filename  );
		return false;
	}
	fclose( fp );


	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Sigma Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}


	//	-----------------------------------------------------------------------
	//	USB̨ނ̎s
	//	-----------------------------------------------------------------------
	gettimeofday( &t1, NULL );

	//	̨Ӱޔ
	if(( mode[0] == 's' ) | ( mode[0] == 'S' ))
	{
		//	SX-USB4
		printf("Target Board = SX-USB4.\n");
		if( !SUS_Usb_Config( handle, filename ))
		{
			printf("Configuration Failed!!!\n");
		}
		else
		{
			printf("Configuration Successful!!\n");
		}
	}
	else if(( mode[0] == 'c' ) | ( mode[0] == 'C' ))
	{
		//	CX-Card5
		printf("Target Board = CX-Card5.\n");
		if( !SUS_Usb_Config_CXCARD5( handle, filename ))
		{
			printf("Configuration Failed!!!\n");
		}
		else
		{
			printf("Configuration Successful!!\n");
		}
	}
	else if(( mode[0] == 'x' ) | ( mode[0] == 'X' ))
	{
		//	Xilinx޲
		printf("Target Board = Xilinx FPGA Board.\n");
		if( !SUS_Usb_Config_KXCARD7( handle, filename, encrypt ))
		{
			printf("Configuration Failed!!!\n");
		}
		else
		{
			printf("Configuration Successful!!\n");
		}
	}
	else
	{
		//	̑(-m߼ݖw,s̏ꍇ)
		//	Xilinx޲
		printf("Target Board = Xilinx FPGA Board.\n");
		if( !SUS_Usb_Config_KXCARD7( handle, filename, encrypt ))
		{
			printf("Configuration Failed!!!\n");
		}
		else
		{
			printf("Configuration Successful!!\n");
		}
	}

	gettimeofday( &t2, NULL );
	if( t1.tv_usec > t2.tv_usec )
	{
		t2.tv_usec += 1000000;
		t2.tv_sec--;
	}
	lapsed_sec = ( t2.tv_sec - t1.tv_sec ) * 1000;
	lapsed_usec = ( t2.tv_usec - t1.tv_usec ) / 1000;
	lapsed_time = 	lapsed_sec + lapsed_usec;
	printf("Configuration time = %dms\n", lapsed_time );
	printf("\n\n");

	usb_close( handle );
	return	true;
}
