//	----------------------------------------------------------------------------------------------------------------
//	SUS޲plibusbٿĳ xx
//	
//	2020.05.07	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂ͓mF
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUS.h"

int		main( int argc, char **argv	)
{
	int						i;
	int						pid = 0;
	int						find = 0;
	unsigned short			id;

	struct					usb_bus *busses;
	struct					usb_bus	*bus;
	struct					usb_device	*dev;
	struct					usb_device	*target_dev;
	usb_dev_handle			*handle;

	unsigned char			temp_get;
	union	UNION_2BYTE		temp;


	printf("\nSUSTemp_Alert Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Sigma Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("\nexample) ./SUSTemp_Alert [-p8005]\n");
	printf("-p ... Target ProductID.(optional)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-p%x", &pid  );
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Sigma ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Sigma ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Sigma ... Device not found!!\n" );
		return	false;
	}

	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Sigma Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	޸ς̐ݒ
	//	d&ؾČɂ͖ɂȂĂ
	//	-----------------------------------------------------------------------
	//	݂̐ݒl擾
	if( !SUS_Temp_Alert( handle, SUS_TEMP_ALERT_GET, 0, &temp_get ))
	{
		printf("TEMP-ALERT(GET) Failed!!!\n\n");
	}
	else
	{
		printf("TEMP-ALERT(GET) Successful!!\n");
		printf(" -> The current setting is %d degrees.\n\n", temp_get );
	}

	//	ǌx30xɐݒ
	if( !SUS_Temp_Alert( handle, SUS_TEMP_ALERT_SET, 30, &temp_get ))
	{
		printf("TEMP-ALERT(SET) Failed!!!\n\n");
	}
	else
	{
		printf("TEMP-ALERT(SET) Successful!!\n");
		printf(" -> The current setting 30 degrees.\n\n");
	}


	//	1bԊuŌ݂̐ݒl16擾
	for(i=0;i<16;++i)
	{
		if( !SUS_Get_FPGA_Temp( handle, 0, &temp.word ))
		{
			printf("Failed to get the FPGA temperature.\n\n");
			usb_close( handle );
			return	true;
		}
		else
		{
			printf("TEMP = %d.%d degrees\n",temp.byte[1], temp.byte[0]);
		}

		sleep( 1 );
	}

	usb_close( handle );
	return	true;
}
